//+------------------------------------------------------------------+
//|                                             Copyright  2007 WRR |
//+------------------------------------------------------------------+
#property copyright "Copyright WRR"
#property link      "http://www.forex-tsd.com/"
//See thread http://www.forex-tsd.com/harmonic-trading/885-price-patterns-gartley-butterfly-bat-11.html
#property indicator_chart_window
string FileName = "ZUP_v67.01_WRR_ZUP_INFO.mq4";
//NOTES
/*

August 24, 2007 

INTRODUCTION  

Hello Traders!  WRR here.  First credit must be given to "nen" for writing ZUP_v67.mt4 indicator (ZUP). 
The original development of the indicator is found at this link: 
http://onix-trade.net/forum/index.php?s=&showtopic=118&view=findpost&p=220949

I have modified the Gartley Patterns section of nen's "ZUP_v67.mq4" indicator in a few places to allow it to export
data into this indicator (ZUP_v67.01_WRR_ZUP_INFO.mq4).  Nen's code with my modifications is called ZUP_v67.01_WRR.mq4.
You also need this file running for this indicator to work properly.

This indicator does the following:

Draws a  text block on the chart with the following:
Is there a pattern?
Which Pattern?
Minimum and maximum price range in which Pattern is valid.

The above is the same information as is available when ZUP is set 
to show one pattern and the infoTF switch is turned on.

In addition to what ZUP does, WRR_ZUP_INFO does this:

Allows you see the text even if Comments from other indicators are running.
This text block can easily be moved anywhere on the chart and tells you:
Pattern Failed?
Size of range in which pattern is valid
Pips Risk to entry if pattern fails.
Alerts when new Patterns form
Alerts when Patterns  FAIL
You can get these Alerts for multiple timeframes by opening the relevant charts.

The only adjustments on the WRR_ZUP_INFO indicator besides font settings and text positions is an
Alert on or off control.

TO GET the ZUP_v67.01_WRR.mq4 INDICATOR TO WORK, not this one, the other one you need, you must check 
the box "Allow DLL imports" in the Common Tab of that indicator's properties.


MODIFICATIONS TO ZUP_v67.mq4 saved as ZUP_v67.01_WRR.mq4 (the other indicator) are as follows:

//Changes and notes to ZUP program by WRR flagged with "WRR".  Use find command in editor to see them.

MOD 01
extern int maxBarToD   = 100;//WRR default=15, 100 so pattern stays visible more bars after it is formed 

Sometimes it takes the pattern several bars to develop and with the default setting of 15 the pattern sometimes
disappears too soon.  Sometimes the pattern fails, then the market comes back again so it looks like the pattern
is working but it already failed.  In this case the setting number can to be reduced.  You can tweak this to your
own preferences.

MOD 02
extern bool   ExtAlert    = true;//WRR optional change from false to true (ZigZag Alert)

This alert which is part of the original ZUP_v67.mq4, alerts you on all timeframes if a new ZigZag forms, 
indicating change in market direction.  For the time being, I prefer turn it on, but it is not necessary 
for this ZUP_v67.01_WRR_Info.mq4 indicator to work.

MOD 04
GlobalVariableDel code has been added to the int deinit() section to remove Global Variables 
(added elsewhere by WRR code) after indicator is turned off or chart period is changed.

MOD 05
//Alert (Symbol(),"  ",Period(),"     ZigZag"); replaced with
Alert (Symbol(),"  ",Period()," ZigZag");//WRR replaced above line (removed "    ")
I removed the Russian language text.  Sorry, I only speak English.  No offence intended.

MOD 06
ObjectSet(nameObj, OBJPROP_BACK, true);  //WRR changed from false to true. This change to OBJPROP_BACK 
makes the retangle outline a solid retangle but allows candle wicks to be seen.


MOD 07
Code was added to the end of the Gartley section of ZUP_v67.mq4 to export these 4 variables using the
GlobalVariableSet command.

vBullBearToNumberPattern (tells you if it is Bullish or Bearish);

vNamePatternToNumberPattern (tells you which pattern it is Gartley, Butterfly, Bat or Crab); 

LevelForDminToNumberPattern (tells you the maximum the pattern can expand before failure), and;

LevelForDmaxToNumberPattern (tells you the minimum the pattern must expand to be valid.

The Levels are the upper and lower extremes of the red box at the end of the pattern denoting where
 "Point D" of the XABCD pattern should end.

*/


//ZUP SETTING
extern bool   PatternAlert = true;//ZUP Alert
//STANDARD DRAWING ROUTINE SETTINGS
extern string Corner = "br";//default is "bl","tl"=top left,"tr"=top right,"bl"=bottom left,"br"=bottom right
extern int    OffsetTopBottom = 0;
extern int    OffsetLeftRight = 0;
extern int    FontSize = 10;//default is 10
extern string FontType ="Arial Black";//default is "Arial Black"
extern color  FontColour= Orange;
extern bool   InBackground = false; 
extern int    SpaceBetweenLines = 4;//Space between lines
extern bool   Display = true;//turn on or of display of info
extern bool   ShowFileName = false;//Turn on or off Standard MT3 title Comment in top left corner of chart.

bool IsStartUpOfProgramFlag = true;//Default=true, to prevent alert each startup and chart timeframe change.
string LastPatternFlag = "";//ZUP FLAG, leave as "".

int init()
   {

/*          
   for debugging (Deletes OLD GlobalVariables)   
   GlobalVariableDel(Symbol()+Period()+"ZupLevelForDminToNumberPatter");
   GlobalVariableDel(Symbol()+Period()+"ZupLevelForDmaxToNumberPattern");
   
   for debugging (Prints all Global Variable Names to Terminal->Experts 
   int var_total = GlobalVariablesTotal();
   string name;
   for(int i=0;i<var_total;i++)
      {
      name=GlobalVariableName(i);
      Print(i,": Global variable name - ",name);
      }           
*/
   
   return(0);
   }
int deinit()
    {    
    //delete objects when removing indicator or changing charts
    int TotalObjects= ObjectsTotal();   
    for (int i= TotalObjects; i>=0; i--)
      {
      string NameOfObject = ObjectName(i);   
      if (StringSubstr(NameOfObject,0,14)=="[WRR_ZUP_INFO_") 
         ObjectDelete(NameOfObject);
      }
    return(0);
    }
int start()
    {           
    if(ShowFileName)
      {
      string comment= FileName + "\n";
      Comment(comment); 
      }
    
    //START ZUP CODE
    double ZupBullBearNum    =  0;
    double ZupPatternsNum    =  0;
    double ZupMinLevel = 0;
    double ZupMaxLevel = 0;  
       
    //Retrieve Numeric Data from ZUP indicator
    if(GlobalVariableCheck(Symbol()+Period()+"ZupBullBearNum"))
      {ZupBullBearNum = GlobalVariableGet(Symbol()+Period()+"ZupBullBearNum");}
    if(GlobalVariableCheck(Symbol()+Period()+"ZupPatternsNum"))
      {ZupPatternsNum = GlobalVariableGet(Symbol()+Period()+"ZupPatternsNum");}
    if(GlobalVariableCheck(Symbol()+Period()+"ZupMinLevel"))
      {ZupMinLevel = GlobalVariableGet(Symbol()+Period()+"ZupMinLevel");}
    if(GlobalVariableCheck(Symbol()+Period()+"ZupMaxLevel"))
      {ZupMaxLevel = GlobalVariableGet(Symbol()+Period()+"ZupMaxLevel");}

//Print("ZupBullBearNum from Info = ",ZupBullBearNum);
//Print("ZupPatternsNum from Info = ",ZupPatternsNum);
//Print("ZupMinLevelfrom Info = ",ZupMinLevel);
//Print("ZupMaxLevel from Info = ",ZupMaxLevel);
       
    //Convert Numeric Data from ZUP indicator to String Data        
    string ZupBullBearString = "";     
    string ZupPatternsString = "";     
    string ZupString01       = "";
    string ZupString02       = "";
             
    if(ZupBullBearNum==1){ZupBullBearString="Bearish";}
    if(ZupBullBearNum==2){ZupBullBearString="Bullish";}
    if(ZupPatternsNum==1){ZupPatternsString="Gartley";}
    if(ZupPatternsNum==2){ZupPatternsString="Butterfly";}
    if(ZupPatternsNum==3){ZupPatternsString="Bat";}
    if(ZupPatternsNum==4){ZupPatternsString="Crab";}
              
    //Create ZUP Testing Strings     
    string PatternNameString;
    string PatternString;
          
    PatternNameString = (ZupBullBearString + " " + ZupPatternsString);           
    PatternString     = (PatternNameString + ", Range: " +
                            DoubleToStr(ZupMinLevel,Digits) + " to " +
                            DoubleToStr(ZupMaxLevel,Digits) + " = " +
                            DoubleToStr(ZupMaxLevel-ZupMinLevel,Digits));
  
   //Tests and Alerts                                                     
   
   //Bearish Pattern
   if(ZupBullBearNum == 1 && DoubleToStr(High[0],Digits) <= DoubleToStr(ZupMaxLevel,Digits))
     {
     ZupString01 = PatternString;            
     ZupString02 = ("Entry Risk: " + DoubleToStr(Close[0]-ZupMaxLevel,Digits)); 
     if(PatternAlert == true && LastPatternFlag != PatternString && IsStartUpOfProgramFlag==false)
       {
       Alert(TimeToStr(CurTime(),TIME_SECONDS)," ",Symbol()," ",GetStringOutputPeriod(Period()),
       " ",PatternNameString);
       }               
     LastPatternFlag = PatternString;            
     }                                                      
                       
   //Bearish Pattern Failure    
   if(ZupBullBearNum == 1 && DoubleToStr(High[0],Digits) > DoubleToStr(ZupMaxLevel,Digits))
     {
     ZupString01     = ("FAILED " + PatternString);          
     ZupString02 = ("Entry Risk: " + DoubleToStr(Close[0]-ZupMaxLevel,Digits));
     if(PatternAlert == true && LastPatternFlag != PatternString && IsStartUpOfProgramFlag==false)
       {
       Alert(TimeToStr(CurTime(),TIME_SECONDS)," ",Symbol()," ",GetStringOutputPeriod(Period()),
       " FAILED ",PatternNameString);
       }           
      LastPatternFlag = PatternString;
     }
      
     //Bullish Pattern    
     if(ZupBullBearNum == 2 && DoubleToStr(Low[0],Digits) >= DoubleToStr(ZupMinLevel,Digits))
       {
       ZupString01     = PatternString;
       ZupString02 = ("Entry Risk: " + DoubleToStr(ZupMinLevel-Close[0],Digits));           
       if(PatternAlert == true && LastPatternFlag != PatternString && IsStartUpOfProgramFlag==false)
         {
         Alert(TimeToStr(CurTime(),TIME_SECONDS)," ",Symbol()," ",GetStringOutputPeriod(Period()),
         " ",PatternNameString);
         }             
         LastPatternFlag = PatternString;             
       }
       
     //Bullish Pattern Failure
     if(ZupBullBearNum == 2 && DoubleToStr(Low[0],Digits) < DoubleToStr(ZupMinLevel,Digits))           
       {
       ZupString01     = ("FAILED " + PatternString);
       ZupString02     = ("Entry Risk: " + DoubleToStr(Close[0]-ZupMinLevel,Digits));          
       if(PatternAlert == true && LastPatternFlag != PatternString && IsStartUpOfProgramFlag==false)
         {
         Alert(TimeToStr(CurTime(),TIME_SECONDS)," ",Symbol()," ",GetStringOutputPeriod(Period()),
         " FAILED ",PatternNameString);
         }                         
         LastPatternFlag = PatternString;
         }                      
      
     //No Pattern
     if(ZupPatternsNum == 0)
       {
       PatternString = ("No ZUP Patterns on " + GetStringOutputPeriod(Period()) + " Now");
       ZupString01 = PatternString;
       ZupString02 = "Risk: N/A"; 
       LastPatternFlag = PatternString;
       }
    IsStartUpOfProgramFlag = false;   
    //END ZUP CODE
          
    //STANDARD DRAWING ROUTINE
    //display data
    if(Display == true)
    {
    int CornerInt;
    int TBMin = 1;//Min distance from top or bottom edge or it may not draw
    int LRMin = 2;//Min distance from left or right edge or it may not draw
    if (Corner == "tl"){CornerInt = 0;}
    if (Corner == "tr"){CornerInt = 1;}
    if (Corner == "bl"){CornerInt = 2;}
    if (Corner == "br"){CornerInt = 3;}  

    //--------------------------------------------------------------------------
    string Name01         = "Pattern and Range";
    string Text01         = ZupString01;
    string Ref01          = "01";
    //--------------------------------------------------------------------------
    string Name02         = "Risk and Version";
    string Text02         = ZupString02 + "   " + FileName;
    string Ref02          = "02";
    //--------------------------------------------------------------------------
    //string Name03         = "Spare";
    //string Text03         = "";
    //string Ref03          = "03";
    //--------------------------------------------------------------------------

    int    Spacer01;
    int    Spacer02;
    //int    Spacer03;

    if(Corner == "tr" || Corner == "tl")//change order of line spacing depending if top or bottom
      {
      //Factor to multiply line spacing by for each new line (0 at top, increment down by one)
      Spacer01 = 0;
      Spacer02 = 1;
      //Spacer03 = 2;
      }
    if(Corner == "bl" || Corner == "br")//change order of line spacing depending if top or bottom
      {
      //Factor to multiply line spacing by for each new line (0 at bottom, increment up by one)
      Spacer01 = 1;
      Spacer02 = 0;
      //Spacer03 = 0;
      }
    //Call Draw Info Function  
    SetDrawInfo
    (Name01,Text01,Ref01,Spacer01
    ,CornerInt,OffsetLeftRight,TBMin,LRMin,SpaceBetweenLines,OffsetTopBottom,InBackground,FontSize,FontType,FontColour);

    SetDrawInfo
    (Name02,Text02,Ref02,Spacer02
    ,CornerInt,OffsetLeftRight,TBMin,LRMin,SpaceBetweenLines,OffsetTopBottom,InBackground,FontSize,FontType,FontColour);
/*
    SetDrawInfo
    (Name03,Text03,Ref03,Spacer03
    ,CornerInt,OffsetLeftRight,TBMin,LRMin,SpaceBetweenLines,OffsetTopBottom,InBackground,FontSize,FontType,FontColour);  
*/
    }
return(0);
}
// FUNCTIONS SECTION ----------------------------------------------------------------------
void SetDrawInfo//FUNCTION to draw one line of text
     (string Name,string Text,string Ref,int Spacer
     ,int CornerInt,int OffsetLeftRight,int TBMin,int LRMin, int SpaceBetweenLines
     ,int OffsetTopBottom,bool InBackground,int FontSize,string FontType,color FontColour)
     {
     string LineName = "[WRR_ZUP_INFO_" + Ref + "] " + Name;  
     ObjectCreate(LineName,OBJ_LABEL,0,0,0);
     ObjectSet(LineName,OBJPROP_CORNER,CornerInt);
     ObjectSet(LineName,OBJPROP_XDISTANCE,LRMin+OffsetLeftRight);
     ObjectSet(LineName,OBJPROP_YDISTANCE,TBMin+OffsetTopBottom+(FontSize+SpaceBetweenLines)*Spacer);
     ObjectSet(LineName,OBJPROP_BACK,InBackground);
     ObjectSetText(LineName,Text,FontSize, FontType,FontColour);   
     }

string GetStringOutputPeriod(int InputPeriod)//FUNCTION to show which chart on alerts
       {
       string StringOutputPeriod;
       if(InputPeriod==1){StringOutputPeriod="1M";}
       if(InputPeriod==5) {StringOutputPeriod="5M";}
       if(InputPeriod==15){StringOutputPeriod="15M";}
       if(InputPeriod==30){StringOutputPeriod="30M";}
       if(InputPeriod==60){StringOutputPeriod="H1";}
       if(InputPeriod==240){StringOutputPeriod="H4";}
       if(InputPeriod==1440){StringOutputPeriod="D1";}
       if(InputPeriod==10080){StringOutputPeriod="W1";}
       if(InputPeriod==43200){StringOutputPeriod="MN";}
       return(StringOutputPeriod);
       }      




